# insert

## Description

Inserts rows of data into a dataset.

## Input / Parameter

| Name    | Description                                                             | Input Type | Default | Options | Required |
| ------- | ----------------------------------------------------------------------- | ---------- | ------- | ------- | -------- |
| dataset | The name of the dataset that is created in Services.                    | Text       | -       | -       | Yes      |
| data    | Multiple dynamic attributes with values associated with each attribute. | Object     | -       | -       | Yes      |
| extra   | The stored value that is passed to all the callbacks.                   | Any        | -       | -       | No       |

## Output

| Description                        | Output Type |
| ---------------------------------- | ----------- |
| Returns the formatted information. | Object      |

### Object

| Key     | Description                                                             | Output Type |
| ------- | ----------------------------------------------------------------------- | ----------- |
| success | Boolean value to denote whether the function was executed successfully. | Text        |
| message | The message to print.                                                   | Text        |
| data    | Any additional message or data to print.                                | Text        |

## Callback

### callback

The action performed if this function runs successfully.

| Description                     | Output Type |
| ------------------------------- | ----------- |
| Returns the newly created data. | Object      |

### errorCallback

The action performed if this function does not run successfully.

| Description               | Output Type |
| ------------------------- | ----------- |
| Returns an error message. | Text        |

## Example

In this example, we will insert rows of data into a table in the local storage.

### Steps

1. Drag a `Local Table` component into the services panel in the service page and then fill the fields. For `fields` field value add `name`and `title` as object key with Text type.

   ![](/files/bExkZ4rODrDAdJz0DJb3)
2. Drag a button component to a page in the mobile designer.

   ![](/files/jo2IgEK8Tp86hJSPJ4YS)
3. Select the event `press` and drag the `Dataset.insert` function to the event flow and fill in the parameter. For the `data` parameter, change it's type to a function / subflow and put `Conversion.toObject` inside it then add `name`, `title` as object key with `name_value`, `title_value` as it's value respectively.

   ![](/files/qbZvfQQ57bAvrO2z5iDT)

### Result

1. The new rows of data should be stored on local storage.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.emobiq.com/emobiq-client/006-actions-and-visual-logic/action-reference/react-native/dataset/insert.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
